#include "RecvFileThread.h"
#include "MySyncObject.h"		// CMySyncObjectg
#include "SendRecvThread.h"		// CSendRecvThreadg
#include "RingBuff.h"			// CRingBuffg

extern void DispMenu();								// j[̕\


CRecvFileThread::CRecvFileThread(CSendRecvThread *pCSendRecvThread, LPSTR pszFileName)
{
	// RXgN^̈o
	m_pCSendRecvThread = pCSendRecvThread;
	m_pszFileName = (LPSTR)calloc(strlen(pszFileName) + 1, sizeof(char));
	DISABLE_C4996
	strcpy(m_pszFileName, pszFileName);
	ENABLE_C4996

	// ϐ̏
	m_fIamZombie = FALSE;
	m_pCMySyncObject = new CMySyncObject();
	m_pCMySyncObject->Initialize();
	m_pCRingBuffCmd = new CRingBuff(CMD_BUFF_SIZE);	// t@CMv/i[p
	m_iRecvFileStatus = RECV_FILE_STAT_IDLE;		// Jڏ RECV_FILE_STAT_IDLE/RECV_FILE_STAT_SIZE/RECV_FILE_STAT_START
													// RECV_FILE_STAT_ING/RECV_FILE_STAT_ABORT
	m_cRecvFileSizeRes = 0;							// t@CM MTCYv(0:l 1:OK -1:G[)
	m_lRecvFileSize = 0;							// MTCY (G[:0 ݎ:ۂ̃TCY)
	m_cRecvFileAbortRes = 0;						// t@CMfv(0:l 1:OK -1:G[)
	m_dwStart = 0;									// ҂^CAEĝߗvs

	m_fdDstFile = -1;								// Mt@CfBXNv^
}


CRecvFileThread::~CRecvFileThread()
{
	if (m_pCMySyncObject != NULL)
		m_pCMySyncObject->Uninitialize();
	SAFE_DELETE(m_pCMySyncObject)
	SAFE_FREE(m_pszFileName)
	SAFE_DELETE(m_pCRingBuffCmd)					// t@CMv/i[p
}

UINT CRecvFileThread::DoWork()
{
	int			iRet = -1;

	while (!m_fStopFlag)
	{
		Sleep(5);
		// t@CMJڏԂɉ̎s
		// ɑ΂鏈ƃt@CM̊֐Ŏs܂
		iRet = DoRecvFileState();
		if ((iRet == 2) || (iRet == -1))	// M/G[ÃXbh]rɂ
			break;
	}
	DispMenu();
	// t@Cclose
	if (m_fdDstFile != -1)
		_close(m_fdDstFile);
	m_pCMySyncObject->Lock();
	m_fIamZombie = TRUE;		// t@CM/sŃ]r
	m_pCMySyncObject->UnLock();
	return((iRet != -1) ? 0 : -1);
}

//----------------------------------------------
// function
//		t@CMJڏԂɉs
// parameter
//		Ȃ
// return
//		0:Ȃ 1:s 2:M -1:G[
//----------------------------------------------
int CRecvFileThread::DoRecvFileState()
{
	int iRet = 0;

	if (((iRet = AnalyzeCmd()) == -1) || (iRet == 2))	// Ȃǂ̉ Ԓl-1̎G[ 2̎t@CM
		goto L_END;

	switch (m_iRecvFileStatus)
	{
		case RECV_FILE_STAT_IDLE:					// ->MTCY҂
			if ((iRet = SendRecvFileSize()) == 1)	// MTCYvpPbg𑗐M
			{
				m_iRecvFileStatus = RECV_FILE_STAT_SIZE;
				m_dwStart = timeGetTime();
			}
			break;
		case RECV_FILE_STAT_SIZE:					// MTCY҂->t@CMJnv
			if ((iRet = CheckRecvFileSizeRes(TIMEOUT_FOR_RES)) == 1)	// ʃ`FbN
			{
				if ((iRet = SendRecvFileStart()) == 1)	// t@COpenāAMJnvpPbg𑗐M
				{
					m_iRecvFileStatus = RECV_FILE_STAT_START;
				}
			}
			break;
		case RECV_FILE_STAT_ABORT:				// f҂->I
			if ((iRet = CheckRecvFileAbortRes(TIMEOUT_FOR_RES)) == 2)
			{
				Locate(1, 10, 2);
				fprintf(stderr, "t@CMf");
				m_iRecvFileStatus = RECV_FILE_STAT_IDLE;
			}
			break;
		default:
			break;
	}
L_END:
	if (iRet == -1)
	{
		Locate(1, 8, 1);
		fprintf(stderr, "t@CMG[");
	}
	return(iRet);
}

//----------------------------------------------
// function
//		t@C̃TCYvpPbg𑗐M
// parameter
//		Ȃ
// return
//		1/-1
//----------------------------------------------
int CRecvFileThread::SendRecvFileSize()
{
	int iRet = -1;

	m_cRecvFileSizeRes = 0;				// M
	// t@C̑M
	if (SendRecvFileSizePacket(m_pszFileName) == FALSE)
		goto L_END;
	iRet = 1;
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CTCYvR}h̑M
// parameter
//		LPSTR	pszFileName	[in]t@C
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::SendRecvFileSizePacket(LPSTR pszFileName)
{
	BOOL		fRet = FALSE;
	RecvFileSizeReqRec	*pRecvFileSizeReq = NULL;
	int			iPacketSize;
	int			iSize;
	LPBYTE		pbDest = NULL;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(RecvFileSizeReqRec);
	pRecvFileSizeReq = (RecvFileSizeReqRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pRecvFileSizeReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileSizeReq->header.wCommand = htons(CMD_RECV_FILE_SIZE_REQ);
	pRecvFileSizeReq->header.wDataLen = htons(sizeof(FileInfoRec));

	Locate(1, 8, 2);
	fprintf(stderr, "t@CM %s", pszFileName);
	// f[^Ƀf[^i[(t@C)
	// t@CΉ̂߂UTF-8ɕύXđM
	iSize = 0;
	pbDest = NULL;
	ConvSJistoUtf8((LPBYTE)pszFileName, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvSJistoUtf8((LPBYTE)pszFileName, pbDest, &iSize);

	memcpy(pRecvFileSizeReq->FileInfo.szFileName, pbDest, iSize);

	// t@CTCYvpPbg̑M
	fRet = m_pCSendRecvThread->SetSendData((char *)pRecvFileSizeReq, iPacketSize);

	SAFE_FREE(pbDest)
	SAFE_FREE(pRecvFileSizeReq);
	return(fRet);
}

//----------------------------------------------
// function
//		t@CMTCYv`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ 1: -1:s܂̓^CAEg 2:t@C݂Ȃ
//----------------------------------------------
int	CRecvFileThread::CheckRecvFileSizeRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwStart) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_cRecvFileSizeRes == -1)				// G[
		iRet = -1;
	else if (m_cRecvFileSizeRes == 1)			// 
	{
		iRet = (m_lRecvFileSize == 0) ? 2 : 1; // t@CTCY0̎̓t@C݂Ȃ
		Locate(1, 10, 2);
		fprintf(stderr, "t@C݂Ȃ");
	}
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMJnv
// parameter
//		Ȃ
// return
//		1/-1
//----------------------------------------------
int CRecvFileThread::SendRecvFileStart()
{
	int		iRet = -1;
	long	lRecvFileSize;

	// t@COpen
	DISABLE_C4996
	m_fdDstFile = _open(m_pszFileName, _O_CREAT | _O_WRONLY | _O_TRUNC | _O_BINARY, _S_IREAD | _S_IWRITE);
	ENABLE_C4996

	// t@C0ŗvƁAt@CM{܂
	lRecvFileSize = (m_fdDstFile == -1) ? 0 : m_lRecvFileSize;

	// t@C, t@C̑M
	if (SendRecvFileStartPacket(m_pszFileName, lRecvFileSize) == FALSE)
		goto L_END;
	iRet = (m_fdDstFile == -1) ? -1 : 1;
L_END:
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMJnR}h̑M
// parameter
//		LPSTR	pszFileName	[in]t@C
//		int		iFileLength	[in]t@C/0:t@CM{Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::SendRecvFileStartPacket(LPSTR pszFileName, int iFileLength)
{
	BOOL		fRet = FALSE;
	RecvFileStartReqRec	*pRecvFileStartReq = NULL;
	int			iPacketSize;
	int			iSize;
	LPBYTE		pbDest = NULL;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(RecvFileStartReqRec);
	pRecvFileStartReq = (RecvFileStartReqRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pRecvFileStartReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileStartReq->header.wCommand = htons(CMD_RECV_FILE_START_REQ);
	pRecvFileStartReq->header.wDataLen = htons(sizeof(FileInfoRec));

	Locate(1, 8, 2);
	fprintf(stderr, "t@CM %s %d(%u)", pszFileName, iFileLength, timeGetTime());
	// f[^Ƀf[^i[(t@CTCYAt@C)
	// t@CΉ̂߂UTF-8ɕύXđM
	iSize = 0;
	pbDest = NULL;
	ConvSJistoUtf8((LPBYTE)pszFileName, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvSJistoUtf8((LPBYTE)pszFileName, pbDest, &iSize);

	memcpy(pRecvFileStartReq->FileInfo.szFileName, pbDest, iSize);
	DISABLE_C4996
	sprintf(pRecvFileStartReq->FileInfo.szFileSize, "%d", iFileLength);
	ENABLE_C4996

	// t@CMJnvpPbg̑M
	fRet = m_pCSendRecvThread->SetSendData((char *)pRecvFileStartReq, iPacketSize);

	SAFE_FREE(pbDest)
	SAFE_FREE(pRecvFileStartReq);
	return(fRet);
}

//----------------------------------------------
// function
//		Mf
//		JڏԕύXAfpPbgM
// parameter
//		Ȃ
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::RecvFileAbort()
{
	BOOL		fRet = FALSE;

	// t@CM̎f
	if (m_iRecvFileStatus != RECV_FILE_STAT_ING)
		goto L_END;

	m_iRecvFileStatus = RECV_FILE_STAT_ABORT;
	m_dwStart = timeGetTime();
	fRet = SendRecvFileAbortPacket();
L_END:
	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̒fvM
// parameter
//		Ȃ
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::SendRecvFileAbortPacket()
{
	BOOL		fRet = FALSE;
	RecvFileAbortReqRec	*pRecvFileAbortReq = NULL;
	int			iPacketSize;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(RecvFileAbortReqRec);
	pRecvFileAbortReq = (RecvFileAbortReqRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pRecvFileAbortReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileAbortReq->header.wCommand = htons(CMD_RECV_FILE_ABORT_REQ);
	pRecvFileAbortReq->header.wDataLen = htons(0);

	Locate(1, 10, 2);
	fprintf(stderr, "t@CMfvM");

	// t@CMfpPbg̑M
	fRet = m_pCSendRecvThread->SetSendData((char *)pRecvFileAbortReq, iPacketSize);
	SAFE_FREE(pRecvFileAbortReq);
	return(fRet);
}

//----------------------------------------------
// function
//		t@CM̒fv`FbN
// parameter
//		DWORD	dwTimeOut	[in]^CAEg
// return
//		0:܂ĂȂ 2: -1:s܂̓^CAEg
//----------------------------------------------
int	CRecvFileThread::CheckRecvFileAbortRes(DWORD dwTimeOut)
{
	int		iRet = 0;

	if (GetdwInterval(timeGetTime(), m_dwStart) >= dwTimeOut)	// ^CAEg
	{
		iRet = -1;
		goto L_END;
	}
	if (m_cRecvFileAbortRes == -1)				// G[
		iRet = -1;
	else if (m_cRecvFileAbortRes == 1)			// 
		iRet = 2;
L_END:
	if (iRet != 0)
	{
		if (m_fdDstFile != -1)
		{
			_close(m_fdDstFile);
			_unlink(m_pszFileName);
		}
		m_fdDstFile = -1;
	}
	return(iRet);
}


//----------------------------------------------
// function
//		t@CMR}h/̉
// parameter
//		Ȃ
// retun
//		0:\ȃf[^i[ĂȂȂ 1:͐ -1:͎s 2:t@CM
//----------------------------------------------
int CRecvFileThread::AnalyzeCmd()
{
	int			iRet = 0;
	HeaderRec	Header;
	WORD		wCmd;
	int			iSize = m_pCRingBuffCmd->GetReadableSize();
	int			iPacketSize, iDataSize;
	LPBYTE		pbPacket = NULL;

	if (iSize < sizeof(HeaderRec))			// wb_TCYɖȂƂ͉Ȃ
		goto L_END;

	// wb_؂ǂݍ݂(pPbgۂƊi[Ă͂)
	m_pCRingBuffCmd->ReadWithoutUpdateHeadPoint((LPBYTE)&Header, sizeof(HeaderRec));
	wCmd = ntohs(Header.wCommand);
	iDataSize = ntohs(Header.wDataLen);
	iPacketSize = iDataSize + sizeof(HeaderRec);
	if (iSize < iPacketSize)				// pPbgTCYɖȂƂ͉Ȃ
		goto L_END;

	pbPacket = (LPBYTE)calloc(iPacketSize, sizeof(BYTE));
	// pPbgŜǂ
	m_pCRingBuffCmd->Read(pbPacket, iPacketSize);

	switch (wCmd)
	{
		case CMD_RECV_FILE_SIZE_RES:			// MTCYvM
			iRet = RecvRecvFileSizeResPacket((RecvFileSizeResRec *)pbPacket);
			break;
		case CMD_RECV_FILE_ING:					// t@CM(t@CMJnv/t@CM->t@CM)
			iRet = RecvRecvFileIngPacket((RecvFileIngRec *)pbPacket);
			break;
		case CMD_RECV_FILE_END_REQ:				// t@CMvM(t@CM->t@CM->)
			iRet = RecvRecvFileEndPacket((RecvFileEndReqRec *)pbPacket);
			break;
		case CMD_RECV_FILE_ABORT_RES:			// MfvM(t@CM->)
			iRet = RecvRecvFileAbortResPacket((RecvFileResRec *)pbPacket);
			break;
		default:
			iRet = -1;
			break;
	}
L_END:
	SAFE_FREE(pbPacket)
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMTCYv
// parameter
//		RecvFileSizeResRec *pbPacket	[in]MpPbg
// return
//		TRUE/FALSE
//----------------------------------------------
int CRecvFileThread::RecvRecvFileSizeResPacket(RecvFileSizeResRec *pbPacket)
{
	int			iRet = 1;

	m_cRecvFileSizeRes = 1;
	m_lRecvFileSize = atol(pbPacket->FileInfo.szFileSize);
	return(iRet);
}

//----------------------------------------------
// function
//		t@CM
// parameter
//		RecvFileIngRec *pbPacket	[in]MpPbg
// return
//		0/1/-1
//----------------------------------------------
int CRecvFileThread::RecvRecvFileIngPacket(RecvFileIngRec *pbPacket)
{
	int			iRet = 0;
	long		lDataSize, lOffset;

	Locate(1, 9, 1);
	fprintf(stderr, "t@CM %s %s", pbPacket->Stat.szOffset, pbPacket->Stat.szSize);

	if (m_iRecvFileStatus == RECV_FILE_STAT_START)
		m_iRecvFileStatus = RECV_FILE_STAT_ING;
	if (m_iRecvFileStatus == RECV_FILE_STAT_ABORT)	//@f͏݂sȂ
	{
		Locate(1, 10, 2);
		fprintf(stderr, "t@CMf");
		iRet = 1;
		goto L_END;
	}

	if (m_iRecvFileStatus != RECV_FILE_STAT_ING)
	{
		iRet = -1;				// JڏԃG[͏I
		goto L_END;
	}
	lDataSize = atol(pbPacket->Stat.szSize);
	lOffset = atol(pbPacket->Stat.szOffset);
	if (lDataSize > 0)
	{
		// t@C쎸sG[ƂďI
		if (_lseek(m_fdDstFile, lOffset, SEEK_SET) == -1)
		{
			iRet = -1;
			goto L_END;
		}
		if (_write(m_fdDstFile, pbPacket->bData, lDataSize) != lDataSize)
		{
			iRet = -1;
			goto L_END;
		}
	}
	iRet = 1;
L_END:
	if (iRet == -1)				// G[I[vĂt@C΃N[YA폜
	{
		if (m_fdDstFile != -1)
		{
			_close(m_fdDstFile);
			_unlink(m_pszFileName);
		}
		m_fdDstFile = -1;
	}
	return(iRet);
}

//----------------------------------------------
// function
//		t@CM
// parameter
//		RecvFileEndReqRec *pbPacket	[in]MpPbg
// return
//		-1/2
//----------------------------------------------
int CRecvFileThread::RecvRecvFileEndPacket(RecvFileEndReqRec *pbPacket)
{
	int			iRet = 0;
	long		lDataSize, lOffset;

	Locate(1, 10, 1);
	fprintf(stderr, "t@CM %s %s(%u)", pbPacket->Stat.szOffset, pbPacket->Stat.szSize, timeGetTime());

	if (m_iRecvFileStatus != RECV_FILE_STAT_ING)
	{
		iRet = -1;				// JڏԃG[͏I
		goto L_END;
	}
	lDataSize = atol(pbPacket->Stat.szSize);
	lOffset = atol(pbPacket->Stat.szOffset);
	if (lDataSize > 0)
	{
		// t@C쎸sG[ƂďI
		if (_lseek(m_fdDstFile, lOffset, SEEK_SET) == -1)
		{
			iRet = -1;
			goto L_END;
		}
		if (_write(m_fdDstFile, pbPacket->bData, lDataSize) != lDataSize)
		{
			iRet = -1;
			goto L_END;
		}
	}
	iRet = 2;
	SendRecvFileEndResPacket(1);		// MvM
L_END:
	if (m_fdDstFile != -1)
	{
		_close(m_fdDstFile);
		if (iRet == -1)					// G[폜
			_unlink(m_pszFileName);
	}
	m_iRecvFileStatus = RECV_FILE_STAT_IDLE;
	m_fdDstFile = -1;
	return(iRet);
}

//----------------------------------------------
// function
//		t@CMvɑ΂鉞𑗐M
// parameter
//		char cResCode	[in]R[h 1/-1
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::SendRecvFileEndResPacket(char cResCode)
{
	BOOL	fRet = FALSE;
	RecvFileResRec	*pRecvFileEndRes = NULL;
	int		iPacketSize;

	iPacketSize = sizeof(RecvFileResRec);
	pRecvFileEndRes = (RecvFileResRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pRecvFileEndRes->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pRecvFileEndRes->header.wCommand = htons(CMD_RECV_FILE_END_RES);
	pRecvFileEndRes->header.wDataLen = htons(sizeof(char));

	pRecvFileEndRes->cResCode = cResCode;

	fRet = m_pCSendRecvThread->SetSendData((char *)pRecvFileEndRes, iPacketSize);
	SAFE_FREE(pRecvFileEndRes)

	return(fRet);
}

//----------------------------------------------
// function
//		t@CMfv
// parameter
//		RecvFileResRec *pbPacket	[in]MpPbg
// return
//		TRUE/FALSE
//----------------------------------------------
int CRecvFileThread::RecvRecvFileAbortResPacket(RecvFileResRec *pbPacket)
{
	int			iRet = 1;

	m_cRecvFileAbortRes = pbPacket->cResCode;
	return(iRet);
}



//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//	  TRUE/FALSE
//----------------------------------------------
BOOL CRecvFileThread::IsZombie()
{
	BOOL	fRet;

	m_pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pCMySyncObject->UnLock();
	return(fRet);
}
